/* tslint:disable */
/* eslint-disable */
/**
 * SIGNATURE API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
import type { RequestArgs } from './base';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, BaseAPI, RequiredError } from './base';

/**
 * 
 * @export
 * @interface Address
 */
export interface Address {
    /**
     * 
     * @type {string}
     * @memberof Address
     */
    'street': string;
    /**
     * 
     * @type {string}
     * @memberof Address
     */
    'house_number': string;
    /**
     * 
     * @type {string}
     * @memberof Address
     */
    'door_number': string;
    /**
     * 
     * @type {string}
     * @memberof Address
     */
    'zip': string;
    /**
     * 
     * @type {string}
     * @memberof Address
     */
    'city': string;
    /**
     * 
     * @type {string}
     * @memberof Address
     */
    'country': string;
    /**
     * 
     * @type {string}
     * @memberof Address
     */
    'ortsteil': string;
}
/**
 * 
 * @export
 * @interface AvailableActionsResponse
 */
export interface AvailableActionsResponse {
    /**
     * 
     * @type {Array<string>}
     * @memberof AvailableActionsResponse
     */
    'insign': Array<AvailableActionsResponseInsignEnum>;
    /**
     * 
     * @type {Array<string>}
     * @memberof AvailableActionsResponse
     */
    'custom': Array<AvailableActionsResponseCustomEnum>;
}

export const AvailableActionsResponseInsignEnum = {
    CreateDocument: 'create_document'
} as const;

export type AvailableActionsResponseInsignEnum = typeof AvailableActionsResponseInsignEnum[keyof typeof AvailableActionsResponseInsignEnum];
export const AvailableActionsResponseCustomEnum = {
    CreateDocument: 'create_document'
} as const;

export type AvailableActionsResponseCustomEnum = typeof AvailableActionsResponseCustomEnum[keyof typeof AvailableActionsResponseCustomEnum];

/**
 * 
 * @export
 * @interface CreateDocumentWebhook
 */
export interface CreateDocumentWebhook {
    /**
     * 
     * @type {string}
     * @memberof CreateDocumentWebhook
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof CreateDocumentWebhook
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof CreateDocumentWebhook
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof CreateDocumentWebhook
     */
    'contact_id': string;
    /**
     * 
     * @type {CreateDocumentWebhookDocument}
     * @memberof CreateDocumentWebhook
     */
    'document': CreateDocumentWebhookDocument;
}
/**
 * 
 * @export
 * @interface CreateDocumentWebhookDocument
 */
export interface CreateDocumentWebhookDocument {
    /**
     * 
     * @type {string}
     * @memberof CreateDocumentWebhookDocument
     */
    'name': string;
    /**
     * 
     * @type {string}
     * @memberof CreateDocumentWebhookDocument
     */
    'file_url': string;
}
/**
 * 
 * @export
 * @interface CreateInsignConfigRequest
 */
export interface CreateInsignConfigRequest {
    /**
     * 
     * @type {CreateInsignConfigRequestPaid}
     * @memberof CreateInsignConfigRequest
     */
    'paid'?: CreateInsignConfigRequestPaid;
    /**
     * 
     * @type {CreateInsignConfigRequestFree}
     * @memberof CreateInsignConfigRequest
     */
    'free'?: CreateInsignConfigRequestFree;
}
/**
 * 
 * @export
 * @interface CreateInsignConfigRequestFree
 */
export interface CreateInsignConfigRequestFree {
    /**
     * 
     * @type {string}
     * @memberof CreateInsignConfigRequestFree
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof CreateInsignConfigRequestFree
     */
    'web_url': string;
    /**
     * 
     * @type {string}
     * @memberof CreateInsignConfigRequestFree
     */
    'username': string;
    /**
     * 
     * @type {string}
     * @memberof CreateInsignConfigRequestFree
     */
    'password': string;
}
/**
 * 
 * @export
 * @interface CreateInsignConfigRequestPaid
 */
export interface CreateInsignConfigRequestPaid {
    /**
     * 
     * @type {string}
     * @memberof CreateInsignConfigRequestPaid
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof CreateInsignConfigRequestPaid
     */
    'web_url': string;
    /**
     * 
     * @type {string}
     * @memberof CreateInsignConfigRequestPaid
     */
    'username': string;
    /**
     * 
     * @type {string}
     * @memberof CreateInsignConfigRequestPaid
     */
    'password': string;
}
/**
 * 
 * @export
 * @interface CustomHandler
 */
export interface CustomHandler {
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'type': CustomHandlerTypeEnum;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'url': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'secret'?: string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'secret_header'?: string;
    /**
     * 
     * @type {boolean}
     * @memberof CustomHandler
     */
    'secret_configured': boolean;
    /**
     * 
     * @type {object}
     * @memberof CustomHandler
     */
    'attributes'?: object;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'updated_at': string;
    /**
     * 
     * @type {string}
     * @memberof CustomHandler
     */
    'organization_id': string;
}

export const CustomHandlerTypeEnum = {
    CreateDocument: 'create_document'
} as const;

export type CustomHandlerTypeEnum = typeof CustomHandlerTypeEnum[keyof typeof CustomHandlerTypeEnum];

/**
 * 
 * @export
 * @interface DocumentData
 */
export interface DocumentData {
    /**
     * 
     * @type {string}
     * @memberof DocumentData
     */
    'language': string;
    /**
     * 
     * @type {string}
     * @memberof DocumentData
     */
    'gender': DocumentDataGenderEnum;
    /**
     * 
     * @type {string}
     * @memberof DocumentData
     */
    'firstname': string;
    /**
     * 
     * @type {string}
     * @memberof DocumentData
     */
    'lastname': string;
    /**
     * 
     * @type {string}
     * @memberof DocumentData
     */
    'phone': string;
    /**
     * 
     * @type {string}
     * @memberof DocumentData
     */
    'birthday': string;
    /**
     * 
     * @type {Address}
     * @memberof DocumentData
     */
    'address': Address;
    /**
     * 
     * @type {string}
     * @memberof DocumentData
     */
    'email': string;
    /**
     * 
     * @type {object}
     * @memberof DocumentData
     */
    'attributes': object;
}

export const DocumentDataGenderEnum = {
    Male: 'male',
    Female: 'female',
    Diverse: 'diverse'
} as const;

export type DocumentDataGenderEnum = typeof DocumentDataGenderEnum[keyof typeof DocumentDataGenderEnum];

/**
 * 
 * @export
 * @interface InsignConfiguration
 */
export interface InsignConfiguration {
    /**
     * 
     * @type {string}
     * @memberof InsignConfiguration
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof InsignConfiguration
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof InsignConfiguration
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof InsignConfiguration
     */
    'updated_at': string;
    /**
     * 
     * @type {InsignConfigurationFree}
     * @memberof InsignConfiguration
     */
    'free'?: InsignConfigurationFree;
    /**
     * 
     * @type {InsignConfigurationPaid}
     * @memberof InsignConfiguration
     */
    'paid'?: InsignConfigurationPaid;
}
/**
 * 
 * @export
 * @interface InsignConfigurationFree
 */
export interface InsignConfigurationFree {
    /**
     * 
     * @type {string}
     * @memberof InsignConfigurationFree
     */
    'username': string;
    /**
     * 
     * @type {string}
     * @memberof InsignConfigurationFree
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof InsignConfigurationFree
     */
    'web_url': string;
}
/**
 * 
 * @export
 * @interface InsignConfigurationPaid
 */
export interface InsignConfigurationPaid {
    /**
     * 
     * @type {string}
     * @memberof InsignConfigurationPaid
     */
    'username': string;
    /**
     * 
     * @type {string}
     * @memberof InsignConfigurationPaid
     */
    'api_url': string;
    /**
     * 
     * @type {string}
     * @memberof InsignConfigurationPaid
     */
    'web_url': string;
}
/**
 * 
 * @export
 * @interface SignatureRequest
 */
export interface SignatureRequest {
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'mode': SignatureRequestModeEnum;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'contact_id': string;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'template_id': string;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'transaction_id': string;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'conversation_id': string;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'gateway_id': string;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'session_name': string;
    /**
     * 
     * @type {DocumentData}
     * @memberof SignatureRequest
     */
    'data': DocumentData;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'messenger_id': string;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'messenger_type': string;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof SignatureRequest
     */
    'channel_id': string;
}

export const SignatureRequestModeEnum = {
    Free: 'free',
    Paid: 'paid'
} as const;

export type SignatureRequestModeEnum = typeof SignatureRequestModeEnum[keyof typeof SignatureRequestModeEnum];

/**
 * 
 * @export
 * @interface SignatureResponse
 */
export interface SignatureResponse {
    /**
     * 
     * @type {string}
     * @memberof SignatureResponse
     */
    'sign_link': string;
}
/**
 * 
 * @export
 * @interface Template
 */
export interface Template {
    /**
     * 
     * @type {string}
     * @memberof Template
     */
    'id': string;
    /**
     * 
     * @type {string}
     * @memberof Template
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof Template
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof Template
     */
    'type': string;
    /**
     * 
     * @type {string}
     * @memberof Template
     */
    'file_id': string;
    /**
     * 
     * @type {object}
     * @memberof Template
     */
    'file': object;
    /**
     * 
     * @type {string}
     * @memberof Template
     */
    'name': string;
    /**
     * 
     * @type {object}
     * @memberof Template
     */
    'mapping'?: object;
    /**
     * 
     * @type {Array<object>}
     * @memberof Template
     */
    'fields'?: Array<object>;
    /**
     * 
     * @type {string}
     * @memberof Template
     */
    'created_at': string;
    /**
     * 
     * @type {string}
     * @memberof Template
     */
    'updated_at': string;
}
/**
 * 
 * @export
 * @interface TemplateRequest
 */
export interface TemplateRequest {
    /**
     * 
     * @type {string}
     * @memberof TemplateRequest
     */
    'name': string;
    /**
     * 
     * @type {string}
     * @memberof TemplateRequest
     */
    'channel_id': string;
    /**
     * 
     * @type {string}
     * @memberof TemplateRequest
     */
    'organization_id': string;
    /**
     * 
     * @type {string}
     * @memberof TemplateRequest
     */
    'type': string;
    /**
     * 
     * @type {string}
     * @memberof TemplateRequest
     */
    'file_id': string;
    /**
     * 
     * @type {Array<object>}
     * @memberof TemplateRequest
     */
    'fields'?: Array<object>;
    /**
     * 
     * @type {object}
     * @memberof TemplateRequest
     */
    'mapping'?: object;
}

/**
 * CustomApi - axios parameter creator
 * @export
 */
export const CustomApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteCustomHandler: async (channelId: string, id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('deleteCustomHandler', 'channelId', channelId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('deleteCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers/{id}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteOrganizationCustomHandler: async (id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('deleteOrganizationCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('deleteOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomHandler: async (channelId: string, id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('getCustomHandler', 'channelId', channelId)
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('getCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers/{id}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getOrganizationCustomHandler: async (id: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getOrganizationCustomHandler', 'id', id)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('getOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listCustomHandlers: async (channelId: string, orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('listCustomHandlers', 'channelId', channelId)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('listCustomHandlers', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listOrganizationCustomHandlers: async (orgId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('listOrganizationCustomHandlers', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreateDocumentWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationWebhook: async (type: OrganizationWebhookTypeEnum, orgId: string, body?: CreateDocumentWebhook, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'type' is not null or undefined
            assertParamExists('organizationWebhook', 'type', type)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('organizationWebhook', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/webhooks/{type}`
                .replace(`{${"type"}}`, encodeURIComponent(String(type)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(body, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerCustomHandler: async (channelId: string, orgId: string, customHandler?: CustomHandler, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('registerCustomHandler', 'channelId', channelId)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('registerCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/handlers`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(customHandler, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerOrganizationCustomHandler: async (orgId: string, customHandler?: CustomHandler, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('registerOrganizationCustomHandler', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/handlers`
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(customHandler, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreateDocumentWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        webhook: async (channelId: string, type: WebhookTypeEnum, orgId: string, body?: CreateDocumentWebhook, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'channelId' is not null or undefined
            assertParamExists('webhook', 'channelId', channelId)
            // verify required parameter 'type' is not null or undefined
            assertParamExists('webhook', 'type', type)
            // verify required parameter 'orgId' is not null or undefined
            assertParamExists('webhook', 'orgId', orgId)
            const localVarPath = `/integrations/custom/organizations/{orgId}/channels{channelId}/webhooks/{type}`
                .replace(`{${"channelId"}}`, encodeURIComponent(String(channelId)))
                .replace(`{${"type"}}`, encodeURIComponent(String(type)))
                .replace(`{${"orgId"}}`, encodeURIComponent(String(orgId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(body, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CustomApi - functional programming interface
 * @export
 */
export const CustomApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CustomApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteCustomHandler(channelId, id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteOrganizationCustomHandler(id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getCustomHandler(channelId, id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getOrganizationCustomHandler(id, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listCustomHandlers(channelId: string, orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<CustomHandler>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listCustomHandlers(channelId, orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async listOrganizationCustomHandlers(orgId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<CustomHandler>>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.listOrganizationCustomHandlers(orgId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreateDocumentWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, body?: CreateDocumentWebhook, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.organizationWebhook(type, orgId, body, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.registerCustomHandler(channelId, orgId, customHandler, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CustomHandler>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.registerOrganizationCustomHandler(orgId, customHandler, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreateDocumentWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async webhook(channelId: string, type: WebhookTypeEnum, orgId: string, body?: CreateDocumentWebhook, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.webhook(channelId, type, orgId, body, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CustomApi - factory interface
 * @export
 */
export const CustomApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CustomApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteCustomHandler(channelId: string, id: string, orgId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteCustomHandler(channelId, id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteOrganizationCustomHandler(id: string, orgId: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteOrganizationCustomHandler(id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get custom handler
         * @param {string} channelId 
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getCustomHandler(channelId: string, id: string, orgId: string, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.getCustomHandler(channelId, id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get organization custom handler
         * @param {string} id 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getOrganizationCustomHandler(id: string, orgId: string, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.getOrganizationCustomHandler(id, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List custom handlers
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listCustomHandlers(channelId: string, orgId: string, options?: any): AxiosPromise<Array<CustomHandler>> {
            return localVarFp.listCustomHandlers(channelId, orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List organization custom handlers
         * @param {string} orgId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        listOrganizationCustomHandlers(orgId: string, options?: any): AxiosPromise<Array<CustomHandler>> {
            return localVarFp.listOrganizationCustomHandlers(orgId, options).then((request) => request(axios, basePath));
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook (organization)
         * @param {OrganizationWebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreateDocumentWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, body?: CreateDocumentWebhook, options?: any): AxiosPromise<void> {
            return localVarFp.organizationWebhook(type, orgId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Register custom handler
         * @param {string} channelId 
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.registerCustomHandler(channelId, orgId, customHandler, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Register organization custom handler
         * @param {string} orgId 
         * @param {CustomHandler} [customHandler] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: any): AxiosPromise<CustomHandler> {
            return localVarFp.registerOrganizationCustomHandler(orgId, customHandler, options).then((request) => request(axios, basePath));
        },
        /**
         * Webhook endpoint for external systems
         * @summary Webhook
         * @param {string} channelId 
         * @param {WebhookTypeEnum} type 
         * @param {string} orgId 
         * @param {CreateDocumentWebhook} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        webhook(channelId: string, type: WebhookTypeEnum, orgId: string, body?: CreateDocumentWebhook, options?: any): AxiosPromise<void> {
            return localVarFp.webhook(channelId, type, orgId, body, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * CustomApi - object-oriented interface
 * @export
 * @class CustomApi
 * @extends {BaseAPI}
 */
export class CustomApi extends BaseAPI {
    /**
     * 
     * @summary Delete custom handler
     * @param {string} channelId 
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public deleteCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).deleteCustomHandler(channelId, id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete organization custom handler
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public deleteOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).deleteOrganizationCustomHandler(id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get custom handler
     * @param {string} channelId 
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public getCustomHandler(channelId: string, id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).getCustomHandler(channelId, id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get organization custom handler
     * @param {string} id 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public getOrganizationCustomHandler(id: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).getOrganizationCustomHandler(id, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List custom handlers
     * @param {string} channelId 
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public listCustomHandlers(channelId: string, orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).listCustomHandlers(channelId, orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary List organization custom handlers
     * @param {string} orgId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public listOrganizationCustomHandlers(orgId: string, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).listOrganizationCustomHandlers(orgId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Webhook endpoint for external systems
     * @summary Webhook (organization)
     * @param {OrganizationWebhookTypeEnum} type 
     * @param {string} orgId 
     * @param {CreateDocumentWebhook} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public organizationWebhook(type: OrganizationWebhookTypeEnum, orgId: string, body?: CreateDocumentWebhook, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).organizationWebhook(type, orgId, body, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Register custom handler
     * @param {string} channelId 
     * @param {string} orgId 
     * @param {CustomHandler} [customHandler] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public registerCustomHandler(channelId: string, orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).registerCustomHandler(channelId, orgId, customHandler, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Register organization custom handler
     * @param {string} orgId 
     * @param {CustomHandler} [customHandler] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public registerOrganizationCustomHandler(orgId: string, customHandler?: CustomHandler, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).registerOrganizationCustomHandler(orgId, customHandler, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Webhook endpoint for external systems
     * @summary Webhook
     * @param {string} channelId 
     * @param {WebhookTypeEnum} type 
     * @param {string} orgId 
     * @param {CreateDocumentWebhook} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CustomApi
     */
    public webhook(channelId: string, type: WebhookTypeEnum, orgId: string, body?: CreateDocumentWebhook, options?: AxiosRequestConfig) {
        return CustomApiFp(this.configuration).webhook(channelId, type, orgId, body, options).then((request) => request(this.axios, this.basePath));
    }
}

/**
 * @export
 */
export const OrganizationWebhookTypeEnum = {
    CreateDocument: 'create_document'
} as const;
export type OrganizationWebhookTypeEnum = typeof OrganizationWebhookTypeEnum[keyof typeof OrganizationWebhookTypeEnum];
/**
 * @export
 */
export const WebhookTypeEnum = {
    CreateDocument: 'create_document'
} as const;
export type WebhookTypeEnum = typeof WebhookTypeEnum[keyof typeof WebhookTypeEnum];


/**
 * InsignApi - axios parameter creator
 * @export
 */
export const InsignApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create Insign configuration
         * @param {string} oid Organization ID
         * @param {CreateInsignConfigRequest} [createInsignConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createInsignConfiguration: async (oid: string, createInsignConfigRequest?: CreateInsignConfigRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('createInsignConfiguration', 'oid', oid)
            const localVarPath = `/integrations/insign/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createInsignConfigRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Insign configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteInsignConfiguration: async (oid: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('deleteInsignConfiguration', 'oid', oid)
            const localVarPath = `/integrations/insign/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Insign configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getInsignConfiguration: async (oid: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'oid' is not null or undefined
            assertParamExists('getInsignConfiguration', 'oid', oid)
            const localVarPath = `/integrations/insign/organizations/{oid}/configurations`
                .replace(`{${"oid"}}`, encodeURIComponent(String(oid)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * InsignApi - functional programming interface
 * @export
 */
export const InsignApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = InsignApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Create Insign configuration
         * @param {string} oid Organization ID
         * @param {CreateInsignConfigRequest} [createInsignConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createInsignConfiguration(oid: string, createInsignConfigRequest?: CreateInsignConfigRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<InsignConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createInsignConfiguration(oid, createInsignConfigRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Insign configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async deleteInsignConfiguration(oid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<void>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.deleteInsignConfiguration(oid, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Insign configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getInsignConfiguration(oid: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<InsignConfiguration>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getInsignConfiguration(oid, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * InsignApi - factory interface
 * @export
 */
export const InsignApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = InsignApiFp(configuration)
    return {
        /**
         * 
         * @summary Create Insign configuration
         * @param {string} oid Organization ID
         * @param {CreateInsignConfigRequest} [createInsignConfigRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createInsignConfiguration(oid: string, createInsignConfigRequest?: CreateInsignConfigRequest, options?: any): AxiosPromise<InsignConfiguration> {
            return localVarFp.createInsignConfiguration(oid, createInsignConfigRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Insign configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        deleteInsignConfiguration(oid: string, options?: any): AxiosPromise<void> {
            return localVarFp.deleteInsignConfiguration(oid, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Insign configuration
         * @param {string} oid Organization ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getInsignConfiguration(oid: string, options?: any): AxiosPromise<InsignConfiguration> {
            return localVarFp.getInsignConfiguration(oid, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * InsignApi - object-oriented interface
 * @export
 * @class InsignApi
 * @extends {BaseAPI}
 */
export class InsignApi extends BaseAPI {
    /**
     * 
     * @summary Create Insign configuration
     * @param {string} oid Organization ID
     * @param {CreateInsignConfigRequest} [createInsignConfigRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof InsignApi
     */
    public createInsignConfiguration(oid: string, createInsignConfigRequest?: CreateInsignConfigRequest, options?: AxiosRequestConfig) {
        return InsignApiFp(this.configuration).createInsignConfiguration(oid, createInsignConfigRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Insign configuration
     * @param {string} oid Organization ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof InsignApi
     */
    public deleteInsignConfiguration(oid: string, options?: AxiosRequestConfig) {
        return InsignApiFp(this.configuration).deleteInsignConfiguration(oid, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Insign configuration
     * @param {string} oid Organization ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof InsignApi
     */
    public getInsignConfiguration(oid: string, options?: AxiosRequestConfig) {
        return InsignApiFp(this.configuration).getInsignConfiguration(oid, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * SettingsApi - axios parameter creator
 * @export
 */
export const SettingsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAvailableActions: async (organizationId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'organizationId' is not null or undefined
            assertParamExists('getAvailableActions', 'organizationId', organizationId)
            const localVarPath = `/settings/organizations/{organizationId}/available-actions`
                .replace(`{${"organizationId"}}`, encodeURIComponent(String(organizationId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SettingsApi - functional programming interface
 * @export
 */
export const SettingsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SettingsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getAvailableActions(organizationId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AvailableActionsResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getAvailableActions(organizationId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SettingsApi - factory interface
 * @export
 */
export const SettingsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SettingsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get available actions for organization
         * @param {string} organizationId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getAvailableActions(organizationId: string, options?: any): AxiosPromise<AvailableActionsResponse> {
            return localVarFp.getAvailableActions(organizationId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * SettingsApi - object-oriented interface
 * @export
 * @class SettingsApi
 * @extends {BaseAPI}
 */
export class SettingsApi extends BaseAPI {
    /**
     * 
     * @summary Get available actions for organization
     * @param {string} organizationId 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SettingsApi
     */
    public getAvailableActions(organizationId: string, options?: AxiosRequestConfig) {
        return SettingsApiFp(this.configuration).getAvailableActions(organizationId, options).then((request) => request(this.axios, this.basePath));
    }
}



/**
 * SignaturesApi - axios parameter creator
 * @export
 */
export const SignaturesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create template
         * @param {TemplateRequest} [templateRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createDocumentTemplate: async (templateRequest?: TemplateRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/integrations/insign/templates`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(templateRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * Creates new signature in inSign (DEPRECATED)
         * @summary Create Signature (DEPRECATED)
         * @param {SignatureRequest} [signatureRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createSignature: async (signatureRequest?: SignatureRequest, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/integrations/insign/signatures`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(signatureRequest, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get template
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDocumentTemplate: async (id: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('getDocumentTemplate', 'id', id)
            const localVarPath = `/integrations/insign/templates/{id}`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Authorization required
            // http bearer authentication required
            await setBearerAuthToObject(localVarHeaderParameter, configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SignaturesApi - functional programming interface
 * @export
 */
export const SignaturesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SignaturesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Create template
         * @param {TemplateRequest} [templateRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createDocumentTemplate(templateRequest?: TemplateRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Template>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createDocumentTemplate(templateRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * Creates new signature in inSign (DEPRECATED)
         * @summary Create Signature (DEPRECATED)
         * @param {SignatureRequest} [signatureRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async createSignature(signatureRequest?: SignatureRequest, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SignatureResponse>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.createSignature(signatureRequest, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get template
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async getDocumentTemplate(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Template>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.getDocumentTemplate(id, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SignaturesApi - factory interface
 * @export
 */
export const SignaturesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SignaturesApiFp(configuration)
    return {
        /**
         * 
         * @summary Create template
         * @param {TemplateRequest} [templateRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createDocumentTemplate(templateRequest?: TemplateRequest, options?: any): AxiosPromise<Template> {
            return localVarFp.createDocumentTemplate(templateRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * Creates new signature in inSign (DEPRECATED)
         * @summary Create Signature (DEPRECATED)
         * @param {SignatureRequest} [signatureRequest] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        createSignature(signatureRequest?: SignatureRequest, options?: any): AxiosPromise<SignatureResponse> {
            return localVarFp.createSignature(signatureRequest, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get template
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        getDocumentTemplate(id: string, options?: any): AxiosPromise<Template> {
            return localVarFp.getDocumentTemplate(id, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * SignaturesApi - object-oriented interface
 * @export
 * @class SignaturesApi
 * @extends {BaseAPI}
 */
export class SignaturesApi extends BaseAPI {
    /**
     * 
     * @summary Create template
     * @param {TemplateRequest} [templateRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SignaturesApi
     */
    public createDocumentTemplate(templateRequest?: TemplateRequest, options?: AxiosRequestConfig) {
        return SignaturesApiFp(this.configuration).createDocumentTemplate(templateRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * Creates new signature in inSign (DEPRECATED)
     * @summary Create Signature (DEPRECATED)
     * @param {SignatureRequest} [signatureRequest] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SignaturesApi
     */
    public createSignature(signatureRequest?: SignatureRequest, options?: AxiosRequestConfig) {
        return SignaturesApiFp(this.configuration).createSignature(signatureRequest, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get template
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SignaturesApi
     */
    public getDocumentTemplate(id: string, options?: AxiosRequestConfig) {
        return SignaturesApiFp(this.configuration).getDocumentTemplate(id, options).then((request) => request(this.axios, this.basePath));
    }
}



